/**
 * 
 */
package arc_eager_perceptron;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Set;
import java.util.Iterator;

/**
 * @author Miguel Ballesteros
 *
 */
public class PercModel {

	int next=0;
	int nextTransition=0;
	
	private HashMap<String, String> featureTranslation=new HashMap<String,String>();
	private HashMap<String, String> transTranslation=new HashMap<String,String>();
	BufferedWriter bwTrain;
	BufferedWriter bwTest;
	public PercModel() {
		try {
			bwTrain = new BufferedWriter(new FileWriter("perceptron_train.perceptron"));
			bwTest = new BufferedWriter(new FileWriter("perceptron_test.perceptron"));
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	public String getperceptronTransition(String perceptronTransition) {
		Set<String> transitions=transTranslation.keySet();
		Iterator<String> dpIt=transitions.iterator();
		while (dpIt.hasNext()) {
			String transition=dpIt.next();
			String perceptronAux=transTranslation.get(transition);
			if (perceptronAux.equals(perceptronTransition)) return transition; 
		}
		return null;
	}
	public void closeBuffers(boolean train){
		try {
			if (train) bwTrain.close();
			else bwTest.close();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	private void addNewFeature (String feature){
		
		String perceptronFeat=featureTranslation.get(feature);
		if (perceptronFeat==null) {
			next++;
			featureTranslation.put(feature,""+next+":1.0");
		}
		
	}
	private void addNewTransition (String transition){
		
		String perceptronFeat=transTranslation.get(transition);
		if (perceptronFeat==null) {
			nextTransition++;
			transTranslation.put(transition,""+nextTransition);
		}
		
	}
	public String getperceptronTransitionSingleFile(String file) {
		BufferedReader br;
		try {
			br = new BufferedReader(new FileReader(file));
			String perceptronTransition="";
			while(br.ready()){
				perceptronTransition=br.readLine();
			}
			br.close();
			Double transition=Double.parseDouble(perceptronTransition);
			Integer transInt=transition.intValue();
			
			Set<String> transitionSet=transTranslation.keySet();
			Iterator<String> dpIt=transitionSet.iterator();
			while (dpIt.hasNext()) {
				String transOutput=dpIt.next();
				String perceptronAux=transTranslation.get(transOutput);
				if (perceptronAux.equals(transInt.toString())) return transOutput; 
			}
		} catch (IOException e) {
			e.printStackTrace();
		}
		
		
		return null;
	}
	
	
	public String getperceptronTransitionSingleInt(Integer i) {
		Set<String> transitionSet=transTranslation.keySet();
		Iterator<String> dpIt=transitionSet.iterator();
		while (dpIt.hasNext()) {
			String transOutput=dpIt.next();
			String perceptronAux=transTranslation.get(transOutput);
			if (perceptronAux.equals(i.toString())) return transOutput; 
		}
		return null;
	}
	
	public void addLine(boolean train, int transition, String label, ArrayList<String[]> stack, ArrayList<String[]> buffer, HashMap<String, String> labels, ArrayList<String> listOfTransitions) {	
		String line="";
		boolean write=false;
		//if (true) {
		if (train) {
			String tranLabel=transition+"="+label;
			addNewTransition(tranLabel);
			line+=transTranslation.get(tranLabel);
		}
		else {
			try {
				bwTest = new BufferedWriter(new FileWriter("perceptron_test.perceptron"));
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			line+="1";
		}
		String[] empty=new String[10];
		for(int i=0;i<10;i++) empty[i]="-1"; //root at the end of the sentence, following Ballesteros and Nivre (CL; 2013)
	
		String[] s0=(!stack.isEmpty())?stack.get(0):empty;
		String[] s1=(stack.size()>1)?stack.get(1):empty;
		String[] s2=(stack.size()>2)?stack.get(2):empty;
		String[] s3=(stack.size()>3)?stack.get(3):empty;
		String[] s4=(stack.size()>4)?stack.get(4):empty;
		
		String[] b0=(!buffer.isEmpty())?buffer.get(buffer.size()-1):empty;
		String[] b1=(buffer.size()>1)?buffer.get(buffer.size()-2):empty;
		String[] b2=(buffer.size()>2)?buffer.get(buffer.size()-3):empty;
		String[] b3=(buffer.size()>3)?buffer.get(buffer.size()-4):empty;
		String[] b4=(buffer.size()>4)?buffer.get(buffer.size()-5):empty;
		
		//history
		Iterator<String> itL=listOfTransitions.iterator();
		for (int i=listOfTransitions.size()-1;i>listOfTransitions.size()-9;i--){
			try{
				String historyTrans=listOfTransitions.get(i);
				this.addNewFeature(historyTrans);line+=" "+featureTranslation.get(historyTrans);
			}
			catch(Exception e){
			}
		}
		//POS S0
		this.addNewFeature("posS0="+s0[4]);line+=" "+featureTranslation.get("posS0="+s0[4]);
		//POS S1
		this.addNewFeature("posS1="+s1[4]);line+=" "+featureTranslation.get("posS1="+s1[4]);
		//POS B0
		this.addNewFeature("posB0="+b0[4]);line+=" "+featureTranslation.get("posB0="+b0[4]);
		//POS B1
		this.addNewFeature("posB1="+b1[4]);line+=" "+featureTranslation.get("posB1="+b1[4]);
		//POS B2
		this.addNewFeature("posB2="+b2[4]);line+=" "+featureTranslation.get("posB2="+b2[4]);
		//POS B3
		this.addNewFeature("posB3="+b3[4]);line+=" "+featureTranslation.get("posB3="+b3[4]);
		//DEPREL S0
		this.addNewFeature("deprelS0="+labels.get(s0[0]));line+=" "+featureTranslation.get("deprelS0="+labels.get(s0[0]));
		//FORM S0
		this.addNewFeature("formS0="+s0[1]);line+=" "+featureTranslation.get("formS0="+s0[1]);
		//FORM B0
		this.addNewFeature("formB0="+b0[1]);line+=" "+featureTranslation.get("formB0="+b0[1]);
		//FEAT B0
		this.addNewFeature("featB0="+b0[5]);line+=" "+featureTranslation.get("featB0="+b0[5]);
		//FEAT B1
		this.addNewFeature("featB1="+b1[5]);line+=" "+featureTranslation.get("featB1="+b1[5]);
		//FEAT S0
		this.addNewFeature("featS0="+s0[5]);line+=" "+featureTranslation.get("featS0="+s0[5]);
		//FEAT S1
		this.addNewFeature("featS1="+s1[5]);line+=" "+featureTranslation.get("featS1="+s1[5]);
		try {
			if (train){	
				bwTrain.write(line+"\n");
			}
			else {
				bwTest.write(line+"\n");
			}
		} catch (IOException e) {
			e.printStackTrace();
		}	
					
	}
}
