package perceptron;
import java.io.*;

/**
 * 
 * @author Miguel Ballesteros
 *
 */

public class Perceptron {
	public static int numIters=0;
	public static int dataSize=0;
    public static void main(String[] args) throws IOException {

	DataReader reader = new DataReader();
	reader.init(args);

	Instance[] train_data = reader.getInstances(args[0]);
	Instance[] test_data = reader.getInstances(args[1]);

	PerceptronModel model = learn(train_data, 50);

	System.out.println("\n\nRegular Perceptron======================================================");
	System.out.println("Final Training Accuracy: " + model.accuracy(train_data));
	System.out.println("Final Testing Accuracy: " + model.accuracy(test_data));
	System.out.println("======================================================");

	model.setToAvgWeights();
	model = learn(train_data, 5);
	System.out.println("\n\nAveraged Perceptron\n======================================================");
	System.out.println("Final Training Accuracy: " + model.accuracy(train_data));
	System.out.println("Final Testing Accuracy: " + model.accuracy(test_data));
	System.out.println("======================================================");
    }

    
    public static PerceptronModel learn(Instance[] train_data, int num_iters) {
	PerceptronModel model = new PerceptronModel();
	

	/*

	  Fill in the main body of the perceptron algorithm

	*/
		Perceptron.numIters=num_iters;
		Perceptron.dataSize=train_data.length;
		
		for (int i=0;i<num_iters;i++) {
			
			for (int t=0;t<train_data.length;t++) {
				int yp=model.predict(train_data[t]);
			
				if (yp!=train_data[t].real_label) { //if it fails predicting
										
					//UPDATE
					double[] updates=new double[model.reader.num_features * model.reader.num_labels];
					double[] features1=train_data[t].getFeatures(yp);
					double[] featuresR=train_data[t].getFeatures(train_data[t].real_label);
					for(int j=0;j<updates.length;j++) {
						updates[j]=featuresR[j]-features1[j];
						
					}
					model.update(updates);
			
					}
				}
			
			}
		return model; // Returns a model with all weights = 0;
    }

}
